﻿using CommonBehaviors.Actions;
using Styx;
using Styx.TreeSharp;
using Styx.WoWInternals.WoWObjects;
using PubFireMage.Core;

#region [Method] - Class Redundancy
using C = PubFireMage.Rotation.Conditions;
using HkM = PubFireMage.Core.Managers.HotkeyManager;
using SB = PubFireMage.Core.Helpers.SpellBook;
using TM = PubFireMage.Core.Managers.TalentManager;
using U = PubFireMage.Core.Unit;
#endregion

namespace PubFireMage.Rotation
{
    class Rotation
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }

        #region [Method] - Combat Buffing
        public static Composite combatBuffing()
        {
            return new PrioritySelector(
                new Decorator(ret => HkM.manualOn || !Me.IsAlive || !Me.GotTarget, new ActionAlwaysSucceed()));
        }
        #endregion

        #region [Method] - Precombat Buffing
        public static Composite preCombatBuffing()
        {
            return new PrioritySelector(
                new Decorator(ret => HkM.manualOn || !Me.IsAlive || Me.IsCasting || Me.IsChanneling || Me.Mounted || Me.OnTaxi, new ActionAlwaysSucceed())
                
                );
        }
        #endregion

        #region [Method] - Rotation Selector
        public static Composite rotationSelector()
        {
            return new PrioritySelector(
                new Decorator(ret => HkM.manualOn || !Me.IsAlive || !Me.GotTarget, new ActionAlwaysSucceed()),
                new Switch<bool>(ret => HkM.aoeOn,
                    new SwitchArgument<bool>(true,
                        new PrioritySelector(
                            
                            )),
                    new SwitchArgument<bool>(false,
                        new PrioritySelector(
                            SB.spellCounterspell.Cast(reqs => Me.CurrentTarget.IsCasting ),
                            SB.spellRuneOfPower.Cast(reqs => Me.CurrentTarget.IsHostile ),
                            SB.spellCombustion.Cast(reqs => Me.HasAura(SB.auraHotStreak)),
                            SB.spellPyroblast.Cast(reqs => Me.HasAura(SB.auraHotStreak)),
                            SB.spellFireBlast.Cast(reqs => Me.HasAura(SB.auraHeatingUp) ),
                            SB.spellPhoenixFlames.Cast(reqs => Me.HasAura(SB.auraHeatingUp)),
                            SB.spellFireball.Cast(reqs => Me.CurrentTarget.IsHostile ),
                            SB.spellScorch.Cast(reqs => Me.IsMoving && Me.CurrentTarget.IsHostile)
                            ))));
        }
        #endregion
    }
}